const request = require('request');

function checkStatus(res, body, resolve, reject) {
  if (res.statusCode >= 200 && res.statusCode < 300) {
    resolve(body);
  } else {
    reject(body);
  }
}

class PackageModifiersUtils {
  static getPackageModifiers(outerChatTreeId, configuration) {
    return new Promise(function(resolve, reject) {
      const chatTreeId = outerChatTreeId.includes('.')
        ? outerChatTreeId.split('.')[1]
        : outerChatTreeId;

      request.get(
        {
          url:
            configuration.INFOCHAT_DATA_SERVER +
            `/packages/${chatTreeId}/findByCompanyId?preventForceNewStructure=true`,
          json: true,
          headers: {
            Authorization: configuration.USER_TOKEN,
          },
        },
        function(err, httpResponse, body) {
          if (!err) {
            checkStatus(httpResponse, body, resolve, reject);
          } else {
            console.log('erro ao obter chat tree modifiers');
            reject(err);
          }
        },
      );
    });
  }
}

module.exports = PackageModifiersUtils;
