const StringUtils = require('./StringUtils');
const IntEncoder = require('./IntEncoder')();

class RequestPreprocessor {
  constructor() {}

  static process(request) {
    return new Promise(resolve => {
      try {
        const processed = Object.assign({}, request);
        processed.text = RequestPreprocessor.processText(processed.text);
        resolve(processed);
      } catch (e) {
        resolve(request);
      }
    });
  }

  static processText(text) {
    const groupId = IntEncoder.extract(text);
    if (groupId) {
      text = text.replace('#' + groupId, ''); // remove groupId if present
    }
    text = text.replace(/\s+/g, ' '); // remove multiple spaces
    return StringUtils.unaccent(text.toLowerCase());
  }
}

module.exports = RequestPreprocessor;
